function [output] = norm_mult_NGG_MVN_PU(data, group, burnin, numbofits, every, pred)

fun2 = @(x, mstar, phi, v, NGGsigma) fun_NGG_PU2(x, mstar, phi, v, NGGsigma);
funcstar = @(x, phi, v, NGGsigma) fstar_NGG2(x, v, phi, NGGsigma);

[n, p] = size(data);
ngroups = max(group);
nstar = zeros(1, ngroups);
for i = 1:ngroups
    nstar(i) = sum(group==i);
end

disp(['n = ' num2str(n)]);
disp(['number of groups = ' num2str(ngroups)]);

probpred = zeros(size(pred, 1), p, ngroups);

s = 1:n;
m = zeros(max(s), ngroups);
sum1 = zeros(p, max(s));
sum2 = zeros(p, p, max(s));
nstar2 = zeros(1, max(s));
for i = 1:n
    sum1(:, s(i)) = sum1(:, s(i)) + data(i, :)';
    sum2(:, :, s(i)) = sum2(:, :, s(i)) + data(i, :)' * data(i, :);
    nstar2(s(i)) = nstar2(s(i)) + 1;
end

for i = 1:max(s)
    for j = 1:ngroups
        m(i, j) = sum((s==i).*(group==j));
    end
end

lambda_prior = 0.01;
nu = p + 5;
Psi_prior = (nu - p - 1) * cov(data) / 9;
mu0 = mean(data);

v = 20 * ones(1, ngroups);

logvsd2 = log(0.01) * ones(1, ngroups);
vaccept2 = zeros(1, ngroups);
vcount2 = zeros(1, ngroups);
logphisd = log(0.01);
phiaccept = 0;
phicount = 0;
logNGGsigmasd = log(0.01);
NGGsigmaaccept = 0;
NGGsigmacount = 0;

holdphi = zeros(1, numbofits);
holdNGGsigma = zeros(1, numbofits);
holdM = zeros(1, numbofits);
holds = zeros(n, numbofits);

M = 1;
NGGsigma = 0.1;
phi = 1;

for it = 1:(burnin+every*numbofits)
    
    if ( mod(it, 1) == 0 )
        disp(['it = ' num2str(it)]);
        disp(['numb clusters = ' num2str(size(m, 1))]);
        disp(['M = ' num2str(M)]);
        disp(['NGGsigma = ' num2str(NGGsigma)]);
        disp(['phi = ' num2str(phi)]);
        disp(' ');
        disp(['phi accept = ' num2str(phiaccept/phicount)]);
        disp(['v accept2 = ' num2str(vaccept2./vcount2)]);
        disp(' ');
    end
    
    
    
    % Update v
    for k = 1:ngroups

        newv = v;
        newv(k) = v(k) * exp(exp(logvsd2(k)) * randn);
        
        intstar = integral(@(x) funcstar(x, phi, v, NGGsigma), - Inf, Inf);
        loglike = - M * intstar;
        
        intstar = integral(@(x) funcstar(x, phi, newv, NGGsigma), - Inf, Inf);
        newloglike = - M * intstar;
        
        
        for k1 = 1:size(m, 1)
            mstar = m(k1, :);
            probstar = integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
            loglike = loglike + log(probstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
            
            newprobstar = integral(@(x) fun2(x, mstar, phi, newv, NGGsigma), -Inf, Inf);
            newloglike = newloglike + log(newprobstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
        end
        
        logaccept = newloglike - loglike + nstar(k) * (log(newv(k)) - log(v(k)));
        
        accept = 1;
        if ( (isreal(logaccept) == 0) ||(isnan(logaccept)==1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
        
        if ( rand < accept )
            v(k) = newv(k);
        end
        
        vaccept2(k) = vaccept2(k) + accept;
        vcount2(k) = vcount2(k) + 1;
        
        logvsd2(k) = logvsd2(k) + 1 / it^(0.55) * (accept - 0.3);
        
    end
   
    
    % Update NGGsigma
    trans = log(NGGsigma - 0.001) - log(0.999 - NGGsigma);
    newtrans = trans + exp(logNGGsigmasd) * randn;
    newNGGsigma = (0.001 + 0.999 * exp(newtrans)) / (1 + exp(newtrans));
           
    intstar = integral(@(x) funcstar(x, phi, v, NGGsigma), - Inf, Inf);
    loglike = - M * intstar;
    
    intstar = integral(@(x) funcstar(x, phi, v, newNGGsigma), - Inf, Inf);
    newloglike = - M * intstar;
            
    for k1 = 1:size(m, 1)
        mstar = m(k1, :);
        probstar = integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
        loglike = loglike + log(probstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
        
        newprobstar = integral(@(x) fun2(x, mstar, phi, v, newNGGsigma), -Inf, Inf);
        newloglike = newloglike + log(newprobstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
    end
       
    logaccept = newloglike - loglike;
    logaccept = logaccept - log(1 / (newNGGsigma - 0.001) + 1 / (0.999 - newNGGsigma)) + log(1 / (NGGsigma - 0.001) + 1 / (0.999 - NGGsigma));
    
    accept = 1;
    if ( (isreal(logaccept) == 0) || (isnan(logaccept)==1) || (isinf(logaccept)==1) )
        accept = 0;
    elseif ( logaccept < 0 )
        accept = exp(logaccept);
    end
    
    if ( rand < accept )
        NGGsigma = newNGGsigma;
    end
    
    NGGsigmaaccept = NGGsigmaaccept + accept;
    NGGsigmacount = NGGsigmacount + 1;
    
    logNGGsigmasd = logNGGsigmasd + 1 / it^(0.55) * (accept - 0.3);

    
    
    
    % Update phi
    newphi = phi * exp(exp(logphisd) * randn);
    
    intstar = integral(@(x) funcstar(x, phi, v, NGGsigma), - Inf, Inf);
    loglike = - M * intstar;
    
    intstar = integral(@(x) funcstar(x, newphi, v, NGGsigma), - Inf, Inf);
    newloglike = - M * intstar;
    
    for k1 = 1:size(m, 1)
        mstar = m(k1, :);
        probstar = integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
        loglike = loglike + log(probstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
        
        newprobstar = integral(@(x) fun2(x, mstar, newphi, v, NGGsigma), -Inf, Inf);
        newloglike = newloglike + log(newprobstar) + sum(gammaln(mstar + newphi)) - ngroups * gammaln(newphi);
    end
    
    logaccept = newloglike - loglike;
    logaccept = logaccept + log(newphi) - log(phi) - newphi + phi;
    
    accept = 1;
    if ( (isreal(logaccept) == 0) || (isnan(logaccept)==1) || (isinf(logaccept)==1) )
        accept = 0;
    elseif ( logaccept < 0 )
        accept = exp(logaccept);
    end
    
    if ( rand < accept )
        phi = newphi;
    end
    
    phiaccept = phiaccept + accept;
    phicount = phicount + 1;
    
    logphisd = logphisd + 1 / it^(0.55) * (accept - 0.3);
    
    
    
    
    
    % Update s
    for j = 1:n
        
        m(s(j), group(j)) = m(s(j), group(j)) - 1;
        sum1(:, s(j)) = sum1(:, s(j)) - data(j, :)';
        sum2(:, :, s(j)) = sum2(:, :, s(j)) - data(j, :)' * data(j, :);
        nstar2(s(j)) = nstar2(s(j)) - 1;
        if ( sum(m(s(j), :)) == 0 )
            m(s(j), :) = [];
            sum1(:, s(j)) = [];
            sum2(:, :, s(j)) = [];
            s(s>s(j)) = s(s>s(j)) - 1;
            nstar2(s(j)) = [];
        end
        
        logprob = zeros(1, size(m, 1) + 1);
        
        for k = 1:size(m, 1)
            mstar = m(k, :);
            mstar2 = m(k, :);
            mstar2(group(j)) = mstar2(group(j)) + 1;
            probstar = integral(@(x) fun2(x, mstar2, phi, v, NGGsigma), -Inf, Inf) / integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
            probstar = probstar * (mstar(group(j)) + phi);
            logprob(k) = log(probstar);
            
            newsum1 = sum1(:, k) + data(j, :)';
            newsum2 = sum2(:, :, k) + data(j, :)' * data(j, :);
            newnstar2 = nstar2(k) + 1;
            
            logprob(k) = logprob(k) + 0.5 * p * (log(nstar2(k) + lambda_prior) - log(newnstar2 + lambda_prior));
            
            x1 = sum1(:, k) + lambda_prior * mu0';
            mat1 = Psi_prior + sum2(:, :, k) + lambda_prior * mu0' * mu0 - x1 * x1' / (nstar2(k) + lambda_prior);
            x2 = newsum1 + lambda_prior * mu0';
            mat2 = Psi_prior + newsum2 + lambda_prior * mu0' * mu0 - x2 * x2' / (newnstar2 + lambda_prior);
            
            logprob(k) = logprob(k) + 0.5 * (nu + nstar2(k)) * log(det(mat1));
            logprob(k) = logprob(k) - 0.5 * (nu + newnstar2) * log(det(mat2));
            
            logprob(k) = logprob(k) + sum(gammaln((nu + newnstar2 + 1 - (1:p)) / 2)) + (nu + newnstar2) * p / 2 * log(2);
            logprob(k) = logprob(k) - sum(gammaln((nu + nstar2(k) + 1 - (1:p)) / 2)) - (nu + nstar2(k)) * p / 2 * log(2);
        end
        mstar2 = zeros(1, ngroups);
        mstar2(group(j)) = mstar2(group(j)) + 1;
        probstar = M * phi * integral(@(x) fun2(x, mstar2, phi, v, NGGsigma), -Inf, Inf);
        logprob(size(m, 1) + 1) = log(probstar);
        newsum1 = data(j, :)';
        newsum2 = data(j, :)' * data(j, :);
        
        logprob(size(m, 1) + 1) = logprob(size(m, 1) + 1) + 0.5 * p * (log(lambda_prior) - log(1 + lambda_prior));
        
        x2 = newsum1 + lambda_prior * mu0';
        mat2 = Psi_prior + newsum2 + lambda_prior * mu0' * mu0 - x2 * x2' / (1 + lambda_prior);
        
        logprob(size(m, 1) + 1) = logprob(size(m, 1) + 1) + 0.5 * nu * log(det(Psi_prior));
        logprob(size(m, 1) + 1) = logprob(size(m, 1) + 1) - 0.5 * (nu + 1) * log(det(mat2));
        
        logprob(size(m, 1) + 1) = logprob(size(m, 1) + 1) + sum(gammaln((nu + 1 + 1 - (1:p)) / 2)) + (nu + 1) * p / 2 * log(2);
        logprob(size(m, 1) + 1) = logprob(size(m, 1) + 1) - sum(gammaln((nu + 1 - (1:p)) / 2)) - nu * p / 2 * log(2);
       
        prob = exp(logprob - max(logprob));
        fprob = cumsum(prob);
        fprob = fprob / fprob(end);
        
        s(j) = 1;
        ustar = rand;
        while ( ustar > fprob(s(j)) )
            s(j) = s(j) + 1;
        end
        
        if ( s(j) > size(m, 1) )
            m = [m; zeros(1, ngroups)];
            sum1(:, end + 1) = data(j, :)';
            sum2(:, :, end + 1) = data(j, :)' * data(j, :);
            nstar2 = [nstar2 1];
        else
            sum1(:, s(j)) = sum1(:, s(j)) + data(j, :)';
            sum2(:, :, s(j)) = sum2(:, :, s(j)) + data(j, :)' * data(j, :);
            nstar2(s(j)) = nstar2(s(j)) + 1;
        end
        m(s(j), group(j)) = m(s(j), group(j)) + 1;
    end
    
    % Update M
    alphastar = 1 + size(m, 1);
    betastar = 1 + integral(@(x) funcstar(x, phi, v, NGGsigma), - Inf, Inf);
    
    M = gamrnd(alphastar, 1 / betastar);

    
    if ( ( it > burnin ) && ( mod(it - burnin, every) == 0) )
        holdphi((it - burnin) / every) = phi;
        holdM((it - burnin) / every) = M;
        holds(:, (it - burnin) / every) = s;
        
        if ( isempty(pred) == 0 )
            probstar0 = zeros(1, size(m, 1) + 1);
            for j = 1:ngroups
                for k = 1:size(m, 1)
                    mstar = m(k, :);
                    mstar2 = m(k, :);
                    mstar2(j) = mstar2(j) + 1;
                    probstar0(k) = integral(@(x) fun2(x, mstar2, phi, v, NGGsigma), -Inf, Inf) / integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
                    probstar0(k) = probstar0(k) * (mstar(j) + phi);
                end
                mstar2 = zeros(1, ngroups);
                mstar2(j) = mstar2(j) + 1;                
                probstar0(size(m, 1) + 1) = M * phi * integral(@(x) fun2(x, mstar2, phi, v, NGGsigma), -Inf, Inf);

                probstar0 = probstar0 / sum(probstar0);
                
                for k = 1:size(m, 1)
                    logprob0 = log(probstar0(k));
                    x1 = sum1(:, k) + lambda_prior * mu0';
                    mat1 = Psi_prior + sum2(:, :, k) + lambda_prior * mu0' * mu0 - x1 * x1' / (nstar2(k) + lambda_prior);
                    
                    alphastar = nu + nstar2(k) - p + 1;
                    for i = 1:p
                        betastar = mat1(i, i);
                        mupost = (sum1(i, k) + lambda_prior * mu0(i)) / (nstar2(k) + lambda_prior);
                        
                        logprob = logprob0 - (alphastar + 0.5) * log(betastar + (nstar2(k) + lambda_prior + 1) / (nstar2(k) + lambda_prior) * (pred(:, i) - mupost).^2);
                        logprob = logprob + 0.5 * log((nstar2(k) + lambda_prior + 1) / (nstar2(k) + lambda_prior)) - 0.5 * log(2 * pi);
                        logprob = logprob + gammaln(alphastar + 0.5) - gammaln(alphastar);
                        logprob = logprob + alphastar * log(betastar);

                        probpred(:, i, j) = probpred(:, i, j) + exp(logprob);
                    end
                end
                logprob0 = log(probstar0(size(m, 1) + 1));
                for i = 1:p
                    alphastar = nu - p + 1;
                    betastar = Psi_prior(i, i);                    
                    mupost = mu0(i);
                    
                    logprob = logprob0 - (alphastar + 0.5) * log(betastar + (lambda_prior + 1) / lambda_prior * (pred(:, i) - mupost).^2);
                    logprob = logprob + 0.5 * log((lambda_prior + 1) / lambda_prior) - 0.5 * log(2 * pi);
                    logprob = logprob + gammaln(alphastar + 0.5) - gammaln(alphastar);
                    logprob = logprob + alphastar * log(betastar);

                    probpred(:, i, j) = probpred(:, i, j) + exp(logprob);
                end
            end
        end
    end
end

probpred = probpred / numbofits;

output = struct('pred', pred, 'probpred', probpred, 'phi', holdphi, 'NGGsigma', holdNGGsigma, 'M', holdM, 's', holds);