function [output] = norm_mult_NGG_PU(data, group, burnin, numbofits, every, pred)

fun2 = @(x, mstar, phi, v, NGGsigma) fun_NGG_PU2(x, mstar, phi, v, NGGsigma);
funcstar = @(x, phi, v, NGGsigma) fstar_NGG2(x, v, phi, NGGsigma);

n = length(data);
ngroups = max(group);
nstar = zeros(1, ngroups);
for i = 1:ngroups
    nstar(i) = sum(group==i);
end

disp(['n = ' num2str(n)]);
disp(['number of groups = ' num2str(ngroups)]);

probpred = zeros(length(pred), ngroups);

s = 1:n;
m = zeros(max(s), ngroups);
sumy = zeros(max(s), 1);
nstar2 = zeros(max(s), 1);
for i = 1:max(s)
    sumy(i) = sum(data(s==i));
    nstar2(i) = sum(s==i);
    for j = 1:ngroups
        m(i, j) = sum((s==i).*(group==j));
    end
end

v = 20 * ones(1, ngroups);

sigmasq = 1;
sigmasq0 = 100;

logvsd2 = log(0.01) * ones(1, ngroups);
vaccept2 = zeros(1, ngroups);
vcount2 = zeros(1, ngroups);
logphisd = log(0.01);
phiaccept = 0;
phicount = 0;
logNGGsigmasd = log(0.01);
NGGsigmaaccept = 0;
NGGsigmacount = 0;

holdphi = zeros(1, numbofits);
holdNGGsigma = zeros(1, numbofits);
holdM = zeros(1, numbofits);
holds = zeros(n, numbofits);

M = 1;
NGGsigma = 0.1;
phi = 1;

for it = 1:(burnin+every*numbofits)
    
    if ( mod(it, 1) == 0 )
        disp(['it = ' num2str(it)]);
        disp(['numb clusters = ' num2str(size(m, 1))]);
        disp(['M = ' num2str(M)]);
        disp(['NGGsigma = ' num2str(NGGsigma)]);
        disp(['phi = ' num2str(phi)]);
        disp(' ');
        disp(['phi accept = ' num2str(phiaccept/phicount)]);
        disp(['v accept = ' num2str(vaccept2./vcount2)]);
        disp(['NGGsigma accept = ' num2str(NGGsigmaaccept/NGGsigmacount)]);
        disp(' ');
    end    
    
    % Update v
    for k = 1:ngroups

        newv = v;
        newv(k) = v(k) * exp(exp(logvsd2(k)) * randn);
        
        intstar = integral(@(x) funcstar(x, phi, v, NGGsigma), - Inf, Inf);
        loglike = - M * intstar;
        
        intstar = integral(@(x) funcstar(x, phi, newv, NGGsigma), - Inf, Inf);
        newloglike = - M * intstar;
        
        for k1 = 1:size(m, 1)
            mstar = m(k1, :);
            probstar = integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
            loglike = loglike + log(probstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
            
            newprobstar = integral(@(x) fun2(x, mstar, phi, newv, NGGsigma), -Inf, Inf);
            newloglike = newloglike + log(newprobstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
        end
        
        logaccept = newloglike - loglike + nstar(k) * (log(newv(k)) - log(v(k)));
        
        accept = 1;
        if ( (isreal(logaccept) == 0) ||(isnan(logaccept)==1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
        
        if ( rand < accept )
            v(k) = newv(k);
        end
        
        vaccept2(k) = vaccept2(k) + accept;
        vcount2(k) = vcount2(k) + 1;
        
        logvsd2(k) = logvsd2(k) + 1 / it^(0.55) * (accept - 0.3);
        
    end
   
    
    
    
    % Update NGGsigma
    trans = log(NGGsigma - 0.001) - log(0.999 - NGGsigma);
    newtrans = trans + exp(logNGGsigmasd) * randn;
    newNGGsigma = (0.001 + 0.999 * exp(newtrans)) / (1 + exp(newtrans));
           
    intstar = integral(@(x) funcstar(x, phi, v, NGGsigma), - Inf, Inf);
    loglike = - M * intstar;
    
    intstar = integral(@(x) funcstar(x, phi, v, newNGGsigma), - Inf, Inf);
    newloglike = - M * intstar;
            
    for k1 = 1:size(m, 1)
        mstar = m(k1, :);
        probstar = integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
        loglike = loglike + log(probstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
        
        newprobstar = integral(@(x) fun2(x, mstar, phi, v, newNGGsigma), -Inf, Inf);
        newloglike = newloglike + log(newprobstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
    end
       
    logaccept = newloglike - loglike;
    logaccept = logaccept - log(1 / (newNGGsigma - 0.001) + 1 / (0.999 - newNGGsigma)) + log(1 / (NGGsigma - 0.001) + 1 / (0.999 - NGGsigma));
    
    accept = 1;
    if ( (isreal(logaccept) == 0) || (isnan(logaccept)==1) || (isinf(logaccept)==1) )
        accept = 0;
    elseif ( logaccept < 0 )
        accept = exp(logaccept);
    end
    
    if ( rand < accept )
        NGGsigma = newNGGsigma;
    end
    
    NGGsigmaaccept = NGGsigmaaccept + accept;
    NGGsigmacount = NGGsigmacount + 1;
    
    logNGGsigmasd = logNGGsigmasd + 1 / it^(0.55) * (accept - 0.3);


    
    
    % Update phi
    newphi = phi * exp(exp(logphisd) * randn);
    
    intstar = integral(@(x) funcstar(x, phi, v, NGGsigma), - Inf, Inf);
    loglike = - M * intstar;
    
    intstar = integral(@(x) funcstar(x, newphi, v, NGGsigma), - Inf, Inf);
    newloglike = - M * intstar;
    
    for k1 = 1:size(m, 1)
        mstar = m(k1, :);
        probstar = integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
        loglike = loglike + log(probstar) + sum(gammaln(mstar + phi)) - ngroups * gammaln(phi);
        
        newprobstar = integral(@(x) fun2(x, mstar, newphi, v, NGGsigma), -Inf, Inf);
        newloglike = newloglike + log(newprobstar) + sum(gammaln(mstar + newphi)) - ngroups * gammaln(newphi);
    end
    
    logaccept = newloglike - loglike;
    logaccept = logaccept + log(newphi) - log(phi) - newphi + phi;
    
    accept = 1;
    if ( (isreal(logaccept) == 0) || (isnan(logaccept)==1) || (isinf(logaccept)==1) )
        accept = 0;
    elseif ( logaccept < 0 )
        accept = exp(logaccept);
    end
    
    if ( rand < accept )
        phi = newphi;
    end
    
    phiaccept = phiaccept + accept;
    phicount = phicount + 1;
    
    logphisd = logphisd + 1 / it^(0.55) * (accept - 0.3);
    
    
    
    % Update s
    for j = 1:n
        
        m(s(j), group(j)) = m(s(j), group(j)) - 1;
        sumy(s(j)) = sumy(s(j)) - data(j);
        nstar2(s(j)) = nstar2(s(j)) - 1;
        if ( sum(m(s(j), :)) == 0 )
            m(s(j), :) = [];
            sumy(s(j)) = [];
            nstar2(s(j)) = [];
            s(s>s(j)) = s(s>s(j)) - 1;
        end
        
        logprob = zeros(1, size(m, 1) + 1);
        
        for k = 1:size(m, 1)
            mstar = m(k, :);
            mstar2 = m(k, :);
            mstar2(group(j)) = mstar2(group(j)) + 1;
            probstar = integral(@(x) fun2(x, mstar2, phi, v, NGGsigma), -Inf, Inf) / integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
            probstar = probstar * (mstar(group(j)) + phi);
            logprob(k) = log(probstar);
            mupost = (sumy(k) / sigmasq) / (sum(mstar) / sigmasq + 1 / sigmasq0);
            varpost = 1 / (sum(mstar) / sigmasq + 1 / sigmasq0);
            logprob(k) = logprob(k) - 0.5 * (data(j) - mupost)^2 / (varpost + sigmasq) - 0.5 * log(varpost + sigmasq);
        end
        mstar2 = zeros(1, ngroups);
        mstar2(group(j)) = mstar2(group(j)) + 1;
        probstar = M * phi * integral(@(x) fun2(x, mstar2, phi, v, NGGsigma), -Inf, Inf);
        logprob(size(m, 1) + 1) = log(probstar);
        mupost = 0;
        varpost = sigmasq0;
        logprob(size(m, 1) + 1) = logprob(size(m, 1) + 1) - 0.5 * (data(j) - mupost)^2 / (varpost + sigmasq) - 0.5 * log(varpost + sigmasq);
        
        prob = exp(logprob - max(logprob));
        fprob = cumsum(prob);
        fprob = fprob / fprob(end);
        
        s(j) = 1;
        ustar = rand;
        while ( ustar > fprob(s(j)) )
            s(j) = s(j) + 1;
        end
        
        if ( s(j) > size(m, 1) )
            m = [m; zeros(1, ngroups)];
            sumy = [sumy; 0];
            nstar2 = [nstar2; 0];
        end
        m(s(j), group(j)) = m(s(j), group(j)) + 1;
        sumy(s(j)) = sumy(s(j)) + data(j);
        nstar2(s(j)) = nstar2(s(j)) + 1;
    end
    
    % Update M
    alphastar = 1 + size(m, 1);
    betastar = 1 + integral(@(x) funcstar(x, phi, v, NGGsigma), - Inf, Inf);
    
    M = gamrnd(alphastar, 1 / betastar);

    
    
    if ( ( it > burnin ) && ( mod(it - burnin, every) == 0) )
        holdphi((it - burnin) / every) = phi;
        holdNGGsigma((it - burnin) / every) = NGGsigma;
        holdM((it - burnin) / every) = M;
        holds(:, (it - burnin) / every) = s;
        if ( isempty(pred) == 0 )
            probstar0 = zeros(1, size(m, 1) + 1);
            for j = 1:ngroups
                for k = 1:size(m, 1)
                    mstar = m(k, :);
                    mstar2 = m(k, :);
                    mstar2(j) = mstar2(j) + 1;
                    probstar0(k) = integral(@(x) fun2(x, mstar2, phi, v, NGGsigma), -Inf, Inf) / integral(@(x) fun2(x, mstar, phi, v, NGGsigma), -Inf, Inf);
                    probstar0(k) = probstar0(k) * (mstar(j) + phi);
                end
                mstar2 = zeros(1, ngroups);
                mstar2(j) = mstar2(j) + 1;
                probstar0(size(m, 1) + 1) = M * phi * integral(@(x) fun2(x, mstar2, phi, v, NGGsigma), -Inf, Inf);
                
                probstar0 = probstar0 / sum(probstar0);
                
                for k = 1:size(m, 1)
                    logprob = log(probstar0(k));
                    mupost = (sumy(k) / sigmasq) / (nstar2(k) / sigmasq + 1 / sigmasq0);
                    varpost = 1 / (sum(mstar) / sigmasq + 1 / sigmasq0);
                    logprob = logprob - 0.5 * (pred - mupost).^2 ./ (varpost + sigmasq) - 0.5 * log(varpost + sigmasq);
                    probpred(:, j) = probpred(:, j) + exp(logprob');
                end
                logprob = log(probstar0(size(m, 1) + 1));
                mupost = 0;
                varpost = sigmasq0;
                logprob = logprob - 0.5 * (pred - mupost).^2 ./ (varpost + sigmasq) - 0.5 * log(varpost + sigmasq);
                probpred(:, j) = probpred(:, j) + exp(logprob');
            end
        end
    end
end

output = struct('pred', pred, 'probpred', probpred, 'phi', holdphi, 'NGGsigma', holdNGGsigma, 'M', holdM, 's', holds);